import { Theme, useTheme } from '@mui/material/styles';
import Box from '@mui/system/Box';
import {
  changeDataPointColors,
  changePrimary,
  toggleDarkMode,
  useAppDispatch,
} from '@graphpolaris/shared/data-access/store';
import styled from 'styled-components';
import { Button } from '@mui/material';

const Div = styled.div`
  // add :{ theme: Theme } if you want to have typing (autocomplete)
  background-color: ${({ theme }: { theme: Theme }) =>
    theme.palette.primary.main};
`;

const SemanticSubstrates = () => {
  const dispatch = useAppDispatch();
  const theme = useTheme();

  return (
    <>
      <Div>
        <h1>semantic substrates, primary.main</h1>
      </Div>
      <div
        style={{
          backgroundColor: theme.palette.primary.dark,
        }}
      >
        <h1>semantic substrates, primary.dark</h1>
      </div>
      <input
        onChange={(v) =>
          dispatch(
            changePrimary({
              main: v.currentTarget.value,
              darkMode: theme.palette.mode,
            })
          )
        }
        type="color"
        name="head"
        value={theme.palette.primary.main}
      />
      <p>Change Primary Color</p>
      <input
        onChange={(v) =>
          dispatch(
            changeDataPointColors([
              v.currentTarget.value,
              ...theme.palette.dataPointColors.slice(1),
            ])
          )
        }
        type="color"
        id="head"
        name="head"
        value={theme.palette.dataPointColors[0]}
      />
      <p>Change dataPointColor 0</p>
      <input
        onChange={(v) =>
          dispatch(
            changeDataPointColors([
              theme.palette.dataPointColors[0],
              v.currentTarget.value,
              ...theme.palette.dataPointColors.slice(2),
            ])
          )
        }
        type="color"
        id="head"
        name="head"
        value={theme.palette.dataPointColors[1]}
      />
      <p>Change dataPointColor 1</p>
      <Button variant="contained" onClick={() => dispatch(toggleDarkMode())}>
        toggle dark mode
      </Button>
    </>
  );
};

export default SemanticSubstrates;
